#include "tjscli.h"
#include <stdio.h>

/**
 * gp@\܂B
 */
static void TJSCLIDisplayUsage()
{
	ZrvlPrintString(TJSCLI_USAGE_STR_TC);
}

tjs_error TJSCLIExecStorage(ttstr filename)
{
	ttstr content;
	tjs_error rv = ZrvlLoadScriptFile(filename, content);

	if (rv != TJS_S_OK) {
		ZrvlPrintString(ttstr(TJS_W("t@Cǂݍݎs: ")) + filename);
		return rv;
	}

	rv = ZrvlExecScript(content, NULL, NULL, filename);
	if (rv != TJS_S_OK) ZrvlPrintString(TJS_W("XNvgss"));

	return rv;
}





/**
 * Gg|CgłB
 */
int main(int argc, char* argv[])
{
	setlocale(LC_ALL, ""); // [Jݒ

	ttstr errmsg;
	int rv = -1;

	// version check
	if (!ZrvlCheckDLLAcceptance(0, 0, 0, 0, 0, ZRVL_DLL_VERSION_ANY, errmsg)) {
		ZrvlPrintString(errmsg);
		abort();
	}

	// ŌɌ '-' Ŏn܂Ȃt@CƌȂB
	if (argc > 1) {
		int fileIndex = -1;

		for (int i = 1; i < argc; i++) {
			if (argv[i][0] != '-') {
				fileIndex = i;
			}
		}

		if (fileIndex < 0) {
			TJSCLIDisplayUsage();
		} else {
			ttstr filename = argv[fileIndex];

			ZrvlInitProgramArguments(argc, argv);
			// ̃L[ŎQƂł悤
			ZrvlAddProgramArgument(TJSCLI_EXECUTE_FILE_NAME_KEY, argv[0]);
			ZrvlAddProgramArgument(TJSCLI_STARTUP_FILE_NAME_KEY, filename);

			rv = TJSCLIExecStorage(filename);
		}

	// Ȃ
	} else {
		TJSCLIDisplayUsage();
	}

	// GW
	ZrvlFreeScriptEngine();

	return rv;
}
